Index: /palm/trunk/SOURCE/advec_s_bc.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_bc.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_s_bc.f90	(revision 1353)
@@ -1002,31 +1010,31 @@
              cip  =  MAX( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
              cim  = -MIN( 0.0_wp, w(k,j,i) * dt_3d * ddzw(k) )
-             cipf = 1.0 - 2.0 * cip
-             cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k,j)   * f2  * ( 1.0 - cipf )                         &
-                    + a1(k,j)   * f8  * ( 1.0 - cipf*cipf )                    &
-                    + a2(k,j)   * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k+1,j) * f2  * ( 1.0 - cimf )                         &
-                    - a1(k+1,j) * f8  * ( 1.0 - cimf*cimf )                    &
-                    + a2(k+1,j) * f24 * ( 1.0 - cimf*cimf*cimf )
+             cipf = 1.0_wp - 2.0_wp * cip
+             cimf = 1.0_wp - 2.0_wp * cim
+             ip   =   a0(k,j)   * f2  * ( 1.0_wp - cipf )                      &
+                    + a1(k,j)   * f8  * ( 1.0_wp - cipf*cipf )                 &
+                    + a2(k,j)   * f24 * ( 1.0_wp - cipf*cipf*cipf )
+             im   =   a0(k+1,j) * f2  * ( 1.0_wp - cimf )                      &
+                    - a1(k+1,j) * f8  * ( 1.0_wp - cimf*cimf )                 &
+                    + a2(k+1,j) * f24 * ( 1.0_wp - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0_wp )
              im   = MAX( im, 0.0_wp )
-             ippb(k,j) = ip * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15) )
-             impb(k,j) = im * MIN( 1.0_wp, sk_p(k+1,j,i) / (ip+im+1E-15) )
+             ippb(k,j) = ip * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15_wp) )
+             impb(k,j) = im * MIN( 1.0_wp, sk_p(k+1,j,i) / (ip+im+1E-15_wp) )
 
              cip  =  MAX( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
              cim  = -MIN( 0.0_wp, w(k-1,j,i) * dt_3d * ddzw(k) )
-             cipf = 1.0 - 2.0 * cip
-             cimf = 1.0 - 2.0 * cim
-             ip   =   a0(k-1,j) * f2  * ( 1.0 - cipf )                         &
-                    + a1(k-1,j) * f8  * ( 1.0 - cipf*cipf )                    &
-                    + a2(k-1,j) * f24 * ( 1.0 - cipf*cipf*cipf )
-             im   =   a0(k,j)   * f2  * ( 1.0 - cimf )                         &
-                    - a1(k,j)   * f8  * ( 1.0 - cimf*cimf )                    &
-                    + a2(k,j)   * f24 * ( 1.0 - cimf*cimf*cimf )
+             cipf = 1.0_wp - 2.0_wp * cip
+             cimf = 1.0_wp - 2.0_wp * cim
+             ip   =   a0(k-1,j) * f2  * ( 1.0_wp - cipf )                      &
+                    + a1(k-1,j) * f8  * ( 1.0_wp - cipf*cipf )                 &
+                    + a2(k-1,j) * f24 * ( 1.0_wp - cipf*cipf*cipf )
+             im   =   a0(k,j)   * f2  * ( 1.0_wp - cimf )                      &
+                    - a1(k,j)   * f8  * ( 1.0_wp - cimf*cimf )                 &
+                    + a2(k,j)   * f24 * ( 1.0_wp - cimf*cimf*cimf )
              ip   = MAX( ip, 0.0_wp )
              im   = MAX( im, 0.0_wp )
-             ipmb(k,j) = ip * MIN( 1.0_wp, sk_p(k-1,j,i) / (ip+im+1E-15) )
-             immb(k,j) = im * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15) )
+             ipmb(k,j) = ip * MIN( 1.0_wp, sk_p(k-1,j,i) / (ip+im+1E-15_wp) )
+             immb(k,j) = im * MIN( 1.0_wp, sk_p(k,j,i)   / (ip+im+1E-15_wp) )
           ENDDO
        ENDDO
@@ -1036,13 +1044,13 @@
        DO  j = nys, nyn
           DO  k = nzb-1, nzt+2
-             m1z = ABS( sk_p(k+1,j,i) - 2.0 * sk_p(k,j,i) + sk_p(k-1,j,i) )
+             m1z = ABS( sk_p(k+1,j,i) - 2.0_wp * sk_p(k,j,i) + sk_p(k-1,j,i) )
              m1n = ABS( sk_p(k+1,j,i) - sk_p(k-1,j,i) )
-             IF ( m1n /= 0.0  .AND.  m1n >= m1z )  THEN
+             IF ( m1n /= 0.0_wp  .AND.  m1n >= m1z )  THEN
                 m1(k,j) = m1z / m1n
-                IF ( m1(k,j) /= 2.0  .AND.  m1n < fmax(2) )  m1(k,j) = 0.0
+                IF ( m1(k,j) /= 2.0_wp  .AND.  m1n < fmax(2) )  m1(k,j) = 0.0_wp
              ELSEIF ( m1n < m1z )  THEN
-                m1(k,j) = -1.0
+                m1(k,j) = -1.0_wp
              ELSE
-                m1(k,j) = 0.0
+                m1(k,j) = 0.0_wp
              ENDIF
           ENDDO
@@ -1051,25 +1059,25 @@
 !
 !--    Compute switch sw
-       sw = 0.0
+       sw = 0.0_wp
        DO  j = nys, nyn
           DO  k = nzb, nzt+1
-             m2 = 2.0 * ABS( a1(k,j) - a12(k,j) ) /                            &
+             m2 = 2.0_wp * ABS( a1(k,j) - a12(k,j) ) /                         &
                   MAX( ABS( a1(k,j) + a12(k,j) ), 1E-35_wp )
-             IF ( ABS( a1(k,j) + a12(k,j) ) < fmax(2) )  m2 = 0.0
-
-             m3 = 2.0 * ABS( a2(k,j) - a22(k,j) ) /                            &
+             IF ( ABS( a1(k,j) + a12(k,j) ) < fmax(2) )  m2 = 0.0_wp
+
+             m3 = 2.0_wp * ABS( a2(k,j) - a22(k,j) ) /                         &
                   MAX( ABS( a2(k,j) + a22(k,j) ), 1E-35_wp )
-             IF ( ABS( a2(k,j) + a22(k,j) ) < fmax(1) )  m3 = 0.0
-
-             t1 = 0.35
-             t2 = 0.35
-             IF ( m1(k,j) == -1.0 )  t2 = 0.12
+             IF ( ABS( a2(k,j) + a22(k,j) ) < fmax(1) )  m3 = 0.0_wp
+
+             t1 = 0.35_wp
+             t2 = 0.35_wp
+             IF ( m1(k,j) == -1.0_wp )  t2 = 0.12_wp
 
 !--          *VOCL STMT,IF(10)
-             IF ( m1(k-1,j) == 1.0 .OR. m1(k,j) == 1.0 .OR. m1(k+1,j) == 1.0   &
-                  .OR.  m2 > t2  .OR.  m3 > t2  .OR.                           &
-                  ( m1(k,j) > t1  .AND.  m1(k-1,j) /= -1.0  .AND.              &
-                    m1(k,j) /= -1.0  .AND.  m1(k+1,j) /= -1.0 )                &
-                )  sw(k,j) = 1.0
+             IF ( m1(k-1,j) == 1.0_wp .OR. m1(k,j) == 1.0_wp                   &
+                  .OR. m1(k+1,j) == 1.0_wp .OR.  m2 > t2  .OR.  m3 > t2  .OR.  &
+                  ( m1(k,j) > t1  .AND.  m1(k-1,j) /= -1.0_wp  .AND.           &
+                    m1(k,j) /= -1.0_wp  .AND.  m1(k+1,j) /= -1.0_wp )          &
+                )  sw(k,j) = 1.0_wp
           ENDDO
        ENDDO
@@ -1082,7 +1090,7 @@
 
 !--          *VOCL STMT,IF(10)
-             IF ( sw(k,j) == 1.0 )  THEN
+             IF ( sw(k,j) == 1.0_wp )  THEN
                 snenn = sk_p(k+1,j,i) - sk_p(k-1,j,i)
-                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9
+                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
                 sterm = ( sk_p(k,j,i) - sk_p(k-1,j,i) ) / snenn
                 sterm = MIN( sterm, 0.9999_wp )
@@ -1095,12 +1103,13 @@
                 ippe(k,j) = sk_p(k-1,j,i) * cip + snenn * (                    &
                             aex(ix) * cip + bex(ix) / dex(ix) * (              &
-                            eex(ix) - EXP( dex(ix)*0.5 * ( 1.0 - 2.0 * cip ) ) &
+                            eex(ix) -                                          &
+                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cip ) )  &
                                                                 )              &
                                                           )
-                IF ( sterm == 0.0001 )  ippe(k,j) = sk_p(k,j,i) * cip
-                IF ( sterm == 0.9999 )  ippe(k,j) = sk_p(k,j,i) * cip
+                IF ( sterm == 0.0001_wp )  ippe(k,j) = sk_p(k,j,i) * cip
+                IF ( sterm == 0.9999_wp )  ippe(k,j) = sk_p(k,j,i) * cip
 
                 snenn = sk_p(k-1,j,i) - sk_p(k+1,j,i)
-                IF ( ABS( snenn ) < 1E-9 )  snenn = 1E-9
+                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
                 sterm = ( sk_p(k,j,i) - sk_p(k+1,j,i) ) / snenn
                 sterm = MIN( sterm, 0.9999_wp )
@@ -1113,5 +1122,6 @@
                 imme(k,j) = sk_p(k+1,j,i) * cim + snenn * (                    &
                             aex(ix) * cim + bex(ix) / dex(ix) * (              &
-                            eex(ix) - EXP( dex(ix)*0.5 * ( 1.0 - 2.0 * cim ) ) &
+                            eex(ix) -                                          &
+                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cim ) ) &
                                                                 )              &
                                                           )
@@ -1121,7 +1131,7 @@
 
 !--          *VOCL STMT,IF(10)
-             IF ( sw(k+1,j) == 1.0 )  THEN
+             IF ( sw(k+1,j) == 1.0_wp )  THEN
                 snenn = sk_p(k,j,i) - sk_p(k+2,j,i)
-                IF ( ABS( snenn ) .LT. 1E-9 )  snenn = 1E-9
+                IF ( ABS( snenn ) .LT. 1E-9_wp )  snenn = 1E-9_wp
                 sterm = ( sk_p(k+1,j,i) - sk_p(k+2,j,i) ) / snenn
                 sterm = MIN( sterm, 0.9999_wp )
@@ -1134,5 +1144,6 @@
                 impe(k,j) = sk_p(k+2,j,i) * cim + snenn * (                    &
                             aex(ix) * cim + bex(ix) / dex(ix) * (              &
-                            eex(ix) - EXP( dex(ix)*0.5 * ( 1.0 - 2.0 * cim ) ) &
+                            eex(ix) -                                          &
+                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cim ) )  &
                                                                 )              &
                                                           )
@@ -1142,7 +1153,7 @@
 
 !--          *VOCL STMT,IF(10)
-             IF ( sw(k-1,j) == 1.0 )  THEN
+             IF ( sw(k-1,j) == 1.0_wp )  THEN
                 snenn = sk_p(k,j,i) - sk_p(k-2,j,i)
-                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9
+                IF ( ABS( snenn ) < 1E-9_wp )  snenn = 1E-9_wp
                 sterm = ( sk_p(k-1,j,i) - sk_p(k-2,j,i) ) / snenn
                 sterm = MIN( sterm, 0.9999_wp )
@@ -1155,5 +1166,6 @@
                 ipme(k,j) = sk_p(k-2,j,i) * cip + snenn * (                    &
                             aex(ix) * cip + bex(ix) / dex(ix) * (              &
-                            eex(ix) - EXP( dex(ix)*0.5 * ( 1.0 - 2.0 * cip ) ) &
+                            eex(ix) -                                          &
+                            EXP( dex(ix)*0.5_wp * ( 1.0_wp - 2.0_wp * cip ) )  &
                                                                 )              &
                                                           )
@@ -1170,8 +1182,8 @@
        DO  j = nys, nyn
           DO  k = nzb+1, nzt
-             fplus  = ( 1.0 - sw(k,j)   ) * ippb(k,j) + sw(k,j)   * ippe(k,j)  &
-                    - ( 1.0 - sw(k+1,j) ) * impb(k,j) - sw(k+1,j) * impe(k,j)
-             fminus = ( 1.0 - sw(k-1,j) ) * ipmb(k,j) + sw(k-1,j) * ipme(k,j)  &
-                    - ( 1.0 - sw(k,j)   ) * immb(k,j) - sw(k,j)   * imme(k,j)
+             fplus  = ( 1.0_wp - sw(k,j)   ) * ippb(k,j) + sw(k,j)   * ippe(k,j) &
+                    - ( 1.0_wp - sw(k+1,j) ) * impb(k,j) - sw(k+1,j) * impe(k,j)
+             fminus = ( 1.0_wp - sw(k-1,j) ) * ipmb(k,j) + sw(k-1,j) * ipme(k,j) &
+                    - ( 1.0_wp - sw(k,j)   ) * immb(k,j) - sw(k,j)   * imme(k,j)
              tendcy = fplus - fminus
 !
@@ -1182,6 +1194,6 @@
 !--          Density correction because of possible remaining divergences
              d_new = d(k,j,i) - ( w(k,j,i) - w(k-1,j,i) ) * dt_3d * ddzw(k)
-             sk_p(k,j,i) = ( ( 1.0 + d(k,j,i) ) * sk_p(k,j,i) - tendcy ) /    &
-                           ( 1.0 + d_new )
+             sk_p(k,j,i) = ( ( 1.0_wp + d(k,j,i) ) * sk_p(k,j,i) - tendcy ) /  &
+                           ( 1.0_wp + d_new )
 !
 !--          Store heat flux for subsequent statistics output.
Index: /palm/trunk/SOURCE/advec_s_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_pw.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_s_pw.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -102,13 +102,13 @@
              DO  k = nzb_s_inner(j,i)+1, nzt
                 tend(k,j,i) = tend(k,j,i)                                      &
-              -0.5 * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
-                     - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
-                     ) * ddx                                                   &
-              -0.5 * ( ( v(k,j+1,i) - v_gtrans ) * ( sk(k,j+1,i) - sk(k,j,i) ) &
-                     - ( v(k,j,i)   - v_gtrans ) * ( sk(k,j-1,i) - sk(k,j,i) ) &
-                     ) * ddy                                                   &
-              -      (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
-                     -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
-                     ) * dd2zu(k)
+              -0.5_wp * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
+                        - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
+                        ) * ddx                                                   &
+              -0.5_wp * ( ( v(k,j+1,i) - v_gtrans ) * ( sk(k,j+1,i) - sk(k,j,i) ) &
+                        - ( v(k,j,i)   - v_gtrans ) * ( sk(k,j-1,i) - sk(k,j,i) ) &
+                        ) * ddy                                                   &
+              -         (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
+                        -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
+                        ) * dd2zu(k)
              ENDDO
           ENDDO
@@ -153,13 +153,13 @@
        DO  k = nzb_s_inner(j,i)+1, nzt
           tend(k,j,i) = tend(k,j,i)                                            &
-              -0.5 * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
-                     - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
-                     ) * ddx                                                   &
-              -0.5 * ( ( v(k,j+1,i) - v_gtrans ) * ( sk(k,j+1,i) - sk(k,j,i) ) &
-                     - ( v(k,j,i)   - v_gtrans ) * ( sk(k,j-1,i) - sk(k,j,i) ) &
-                     ) * ddy                                                   &
-              -      (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
-                     -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
-                     ) * dd2zu(k)
+              -0.5_wp * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
+                        - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
+                        ) * ddx                                                   &
+              -0.5_wp * ( ( v(k,j+1,i) - v_gtrans ) * ( sk(k,j+1,i) - sk(k,j,i) ) &
+                        - ( v(k,j,i)   - v_gtrans ) * ( sk(k,j-1,i) - sk(k,j,i) ) &
+                        ) * ddy                                                   &
+              -         (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
+                        -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
+                        ) * dd2zu(k)
        ENDDO
 
Index: /palm/trunk/SOURCE/advec_s_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_up.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_s_up.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -106,6 +106,6 @@
 !
 !--             x-direction
-                ukomp = 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
-                IF ( ukomp > 0.0 )  THEN
+                ukomp = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
+                IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
                                          ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
@@ -116,6 +116,6 @@
 !
 !--             y-direction
-                vkomp = 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
-                IF ( vkomp > 0.0 )  THEN
+                vkomp = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
+                IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
                                          ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
@@ -126,6 +126,6 @@
 !
 !--             z-direction
-                wkomp = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
-                IF ( wkomp > 0.0 )  THEN
+                wkomp = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+                IF ( wkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
                                          ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
@@ -182,6 +182,6 @@
 !
 !--       x-direction
-          ukomp = 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
-          IF ( ukomp > 0.0 )  THEN
+          ukomp = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
+          IF ( ukomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
                                          ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
@@ -192,6 +192,6 @@
 !
 !--       y-direction
-          vkomp = 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
-          IF ( vkomp > 0.0 )  THEN
+          vkomp = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
+          IF ( vkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
                                          ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
@@ -202,6 +202,6 @@
 !
 !--       z-direction
-          wkomp = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
-          IF ( wkomp > 0.0 )  THEN
+          wkomp = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+          IF ( wkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
                                          ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
Index: /palm/trunk/SOURCE/advec_u_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_u_pw.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_u_pw.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -89,10 +89,10 @@
        REAL(wp)    ::  gv !:
  
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
        DO  i = nxlu, nxr
           DO  j = nys, nyn
              DO  k = nzb_u_inner(j,i)+1, nzt
-                tend(k,j,i) = tend(k,j,i) - 0.25 * (                           &
+                tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                        &
                          ( u(k,j,i+1) * ( u(k,j,i+1) + u(k,j,i) - gu )         &
                          - u(k,j,i-1) * ( u(k,j,i) + u(k,j,i-1) - gu ) ) * ddx &
@@ -102,5 +102,5 @@
                          - u(k-1,j,i) * ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
                                                                   * ddzw(k)    &
-                                                   )
+                                                      )
              ENDDO
           ENDDO
@@ -139,8 +139,8 @@
        REAL(wp)    ::  gv !:
 
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
        DO  k = nzb_u_inner(j,i)+1, nzt
-          tend(k,j,i) = tend(k,j,i) - 0.25 * (                                 &
+          tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                              &
                          ( u(k,j,i+1) * ( u(k,j,i+1) + u(k,j,i) - gu )         &
                          - u(k,j,i-1) * ( u(k,j,i) + u(k,j,i-1) - gu ) ) * ddx &
@@ -150,5 +150,5 @@
                          - u(k-1,j,i) * ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
                                                                   * ddzw(k)    &
-                                             )
+                                                )
        ENDDO
 
Index: /palm/trunk/SOURCE/advec_u_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_u_up.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_u_up.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -96,5 +96,5 @@
 !--             x-direction
                 ukomp = u(k,j,i) - u_gtrans
-                IF ( ukomp > 0.0 )  THEN
+                IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
                                          ( u(k,j,i) - u(k,j,i-1) ) * ddx
@@ -105,7 +105,7 @@
 !
 !--             y-direction
-                vkomp = 0.25 * ( v(k,j,i)   + v(k,j+1,i) +                     &
+                vkomp = 0.25_wp * ( v(k,j,i)   + v(k,j+1,i) +                  &
                                  v(k,j,i-1) + v(k,j+1,i-1) ) - v_gtrans
-                IF ( vkomp > 0.0 )  THEN
+                IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
                                          ( u(k,j,i) - u(k,j-1,i) ) * ddy
@@ -116,7 +116,7 @@
 !
 !--             z-direction
-                wkomp = 0.25 * ( w(k,j,i)   + w(k-1,j,i) +                     &
+                wkomp = 0.25_wp * ( w(k,j,i)   + w(k-1,j,i) +                  &
                                  w(k,j,i-1) + w(k-1,j,i-1) )
-                IF ( wkomp > 0.0 )  THEN
+                IF ( wkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
                                          ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
@@ -168,5 +168,5 @@
 !--       x-direction
           ukomp = u(k,j,i) - u_gtrans
-          IF ( ukomp > 0.0 )  THEN
+          IF ( ukomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
                                          ( u(k,j,i) - u(k,j,i-1) ) * ddx
@@ -177,7 +177,7 @@
 !
 !--       y-direction
-          vkomp = 0.25 * ( v(k,j,i) + v(k,j+1,i) + v(k,j,i-1) + v(k,j+1,i-1)   &
+          vkomp = 0.25_wp * ( v(k,j,i) + v(k,j+1,i) + v(k,j,i-1) + v(k,j+1,i-1) &
                          ) - v_gtrans
-          IF ( vkomp > 0.0 )  THEN
+          IF ( vkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
                                          ( u(k,j,i) - u(k,j-1,i) ) * ddy
@@ -188,6 +188,6 @@
 !
 !--       z-direction
-          wkomp = 0.25 * ( w(k,j,i) + w(k-1,j,i) + w(k,j,i-1) + w(k-1,j,i-1) )
-          IF ( wkomp > 0.0 )  THEN
+          wkomp = 0.25_wp * ( w(k,j,i) + w(k-1,j,i) + w(k,j,i-1) + w(k-1,j,i-1) )
+          IF ( wkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
                                          ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
Index: /palm/trunk/SOURCE/advec_v_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_v_pw.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_v_pw.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -90,10 +90,10 @@
  
 
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
        DO  i = nxl, nxr
           DO  j = nysv, nyn
              DO  k = nzb_v_inner(j,i)+1, nzt
-                tend(k,j,i) = tend(k,j,i) - 0.25 * (                           &
+                tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                        &
                          ( v(k,j,i+1) * ( u(k,j-1,i+1) + u(k,j,i+1) - gu )     &
                          - v(k,j,i-1) * ( u(k,j-1,i) + u(k,j,i) - gu ) ) * ddx &
@@ -103,5 +103,5 @@
                          - v(k-1,j,i) * ( w(k-1,j-1,i) + w(k-1,j,i) ) )        &
                                                                   * ddzw(k)    &
-                                                   )
+                                                      )
              ENDDO
           ENDDO
@@ -141,8 +141,8 @@
 
 
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
        DO  k = nzb_v_inner(j,i)+1, nzt
-          tend(k,j,i) = tend(k,j,i) - 0.25 * (                                 &
+          tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                              &
                          ( v(k,j,i+1) * ( u(k,j-1,i+1) + u(k,j,i+1) - gu )     &
                          - v(k,j,i-1) * ( u(k,j-1,i) + u(k,j,i) - gu ) ) * ddx &
@@ -152,5 +152,5 @@
                          - v(k-1,j,i) * ( w(k-1,j-1,i) + w(k-1,j,i) ) )        &
                                                                   * ddzw(k)    &
-                                             )
+                                                )
        ENDDO
  
Index: /palm/trunk/SOURCE/advec_v_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_v_up.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_v_up.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -95,7 +95,7 @@
 !
 !--             x-direction
-                ukomp = 0.25 * ( u(k,j,i)   + u(k,j-1,i) +                     &
+                ukomp = 0.25_wp * ( u(k,j,i)   + u(k,j-1,i) +                  &
                                  u(k,j,i+1) + u(k,j-1,i+1) ) - u_gtrans
-                IF ( ukomp > 0.0 )  THEN
+                IF ( ukomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - ukomp *                         &
                                          ( v(k,j,i) - v(k,j,i-1) ) * ddx
@@ -107,5 +107,5 @@
 !--             y-direction
                 vkomp = v(k,j,i) - v_gtrans
-                IF ( vkomp > 0.0 )  THEN
+                IF ( vkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - vkomp *                         &
                                          ( v(k,j,i) - v(k,j-1,i) ) * ddy
@@ -116,7 +116,7 @@
 !
 !--             z-direction
-                wkomp = 0.25 * ( w(k,j,i)  + w(k-1,j,i) +                      &
+                wkomp = 0.25_wp * ( w(k,j,i)  + w(k-1,j,i) +                   &
                                  w(k,j-1,i) + w(k-1,j-1,i) )
-                IF ( wkomp > 0.0 )  THEN
+                IF ( wkomp > 0.0_wp )  THEN
                    tend(k,j,i) = tend(k,j,i) - wkomp *                         &
                                          ( v(k,j,i) - v(k-1,j,i) ) * ddzu(k)
@@ -167,7 +167,7 @@
 !
 !--       x-direction
-          ukomp = 0.25 * ( u(k,j,i) + u(k,j-1,i) + u(k,j,i+1) + u(k,j-1,i+1)   &
+          ukomp = 0.25_wp * ( u(k,j,i) + u(k,j-1,i) + u(k,j,i+1) + u(k,j-1,i+1) &
                          ) - u_gtrans
-          IF ( ukomp > 0.0 )  THEN
+          IF ( ukomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - ukomp *                               &
                                          ( v(k,j,i) - v(k,j,i-1) ) * ddx
@@ -179,5 +179,5 @@
 !--       y-direction
           vkomp = v(k,j,i) - v_gtrans
-          IF ( vkomp > 0.0 )  THEN
+          IF ( vkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - vkomp *                               &
                                          ( v(k,j,i) - v(k,j-1,i) ) * ddy
@@ -188,6 +188,6 @@
 !
 !--       z-direction
-          wkomp = 0.25 * ( w(k,j,i) + w(k-1,j,i) + w(k,j-1,i) + w(k-1,j-1,i) )
-          IF ( wkomp > 0.0 )  THEN
+          wkomp = 0.25_wp * ( w(k,j,i) + w(k-1,j,i) + w(k,j-1,i) + w(k-1,j-1,i) )
+          IF ( wkomp > 0.0_wp )  THEN
              tend(k,j,i) = tend(k,j,i) - wkomp *                               &
                                          ( v(k,j,i) - v(k-1,j,i) ) * ddzu(k)
Index: /palm/trunk/SOURCE/advec_w_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_w_pw.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_w_pw.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -90,10 +90,10 @@
 
  
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
        DO  i = nxl, nxr
           DO  j = nys, nyn
              DO  k = nzb_w_inner(j,i)+1, nzt
-                tend(k,j,i) = tend(k,j,i) - 0.25 * (                           &
+                tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                        &
                          ( w(k,j,i+1) * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )     &
                          - w(k,j,i-1) * ( u(k+1,j,i) + u(k,j,i) - gu ) ) * ddx &
@@ -103,5 +103,5 @@
                          - w(k-1,j,i) * ( w(k,j,i) + w(k-1,j,i) ) )            &
                                                                   * ddzu(k+1)  &
-                                                   )
+                                                      )
              ENDDO
           ENDDO
@@ -140,8 +140,8 @@
        REAL(wp)    ::  gv !:
 
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
        DO  k = nzb_w_inner(j,i)+1, nzt
-          tend(k,j,i) = tend(k,j,i) - 0.25 * (                                 &
+          tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                              &
                          ( w(k,j,i+1) * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )     &
                          - w(k,j,i-1) * ( u(k+1,j,i) + u(k,j,i) - gu ) ) * ddx &
